/*
 * $Id: msghu852.c,v 1.4 2000/04/15 03:09:28 vszel Exp $
 */

/*
 * Harbour Project source code:
 * Language Support Module (HU852)
 *
 * Copyright 2000 Victor Szakats <info@szelvesz.hu>
 * www - http://www.harbour-project.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version, with one exception:
 *
 * The exception is that if you link the Harbour Runtime Library (HRL)
 * and/or the Harbour Virtual Machine (HVM) with other files to produce
 * an executable, this does not by itself cause the resulting executable
 * to be covered by the GNU General Public License. Your use of that
 * executable is in no way restricted on account of linking the HRL
 * and/or HVM code into it.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA (or visit
 * their web site at http://www.gnu.org/).
 *
 */

/* Language name: Hungarian */
/* ISO language code (2 chars): HU */
/* Codepage: 852 */

#include "hbapilng.h"

static HB_LANG s_lang =
{
   {
      /* Identification */
   
      "HU852",                     /* ID */
      "Hungarian",                 /* Name (in English) */
      "Magyar",                    /* Name (in native language) */
      "HU",                        /* RFC ID */
      "852",                       /* Codepage */
      "$Revision: 1.4 $ $Date: 2000/04/15 03:09:28 $",         /* Version */
   
      /* Month names */
   
      "janur",
      "februr",
      "mrcius",
      "prilis",
      "mjus",
      "jnius",
      "jlius",
      "augusztus",
      "szeptember",
      "oktber",
      "november",
      "december",
   
      /* Day names */
   
      "vasrnap",
      "htf",
      "kedd",
      "szerda",
      "cstrtk",
      "pntek",
      "szombat",
   
      /* CA-Cl*pper compatible natmsg items */
   
      "Adatbzisok       Ttelszm    Utols md.     Mret",
      "Kri a tovbbi rszeket?",
      "lapszm",
      "** sszesen **",
      "* Rszsszesen *",
      "*** Mindsszesen ***",
      "Ins",
      "   ",
      "Rossz dtum",
      " Hatrok ",
      " - ",
      "I/N",
      "INVALID EXPRESSION",
   
      /* Error description names */
   
      "Ismeretlen hiba",
      "Paramter hiba",
      "Tmbindex hiba",
      "Karakteres vltoz tlcsorduls",
      "Numerikus tlcsorduls",
      "Nullval val oszts",
      "Numerikus hiba",
      "Szintaktikus hiba",
      "Tl sszetett mvelet",
      "",
      "",
      "Kevs memria",
      "Nem definilt fggvny",
      "Nem exportlt metdus",
      "Nem ltez vltoz",
      "Nem ltez munkaterlet nv",
      "Nem exportlt vltoz",
      "Helytelen munkaterlet nv",
      "Mr hasznlt munkaterlet nv",
      "",
      "Ltrehozsi hiba",
      "Megnyitsi hiba",
      "Lezrsi hiba",
      "Olvassi hiba",
      "rs hiba",
      "Nyomtatsi hiba",
      "",
      "",
      "",
      "",
      "Nem tmogatott mvelet",
      "Korlt tllpve",
      "Index hiba felfedezve",
      "Nem megfelel adattpus",
      "Tl szles adat",
      "Nem megnyitott munkaterlet",
      "Nem indexelt munkaterlet",
      "Kizrlagos megnyitsi md szksges",
      "Zrols szksges",
      "rs nem megengedett",
      "Zrols nem sikerlt j rekord felvitelekor",
      "Zrols nem sikerlt",
      "",
      "",
      "",
      "",
      "tmbelem hozzfrs",
      "tmbelem rtkads",
      "tmbelem dimenzi",
      "nem tmb",
      "feltteles",
   
      /* Internal error names */
   
      "Kezelhetetlen hiba %lu: ",
      "Hiba kezelsi hiba",
      "Nincs ERRORBLOCK() a hiba kezelshez", 
      "Tl sok rekurzv hiba kezel hvs", 
      "Az RDD hibs vagy nem sikerlt betlteni",
      "Nem megfelel tpus metdus (%s)",
      "hb_xgrab can't allocate memory", 
      "hb_xrealloc called with a NULL pointer", 
      "hb_xrealloc called with an invalid pointer", 
      "hb_xrealloc can't reallocate memory", 
      "hb_xfree called with an invalid pointer", 
      "hb_xfree called with a NULL pointer", 
      "Can\'t locate the starting procedure: \'%s\'",
      "No starting procedure", 
      "Unsupported VM opcode", 
      "Symbol item expected from %s",
      "Invalid symbol type for self from %s", 
      "Codeblock expected from %s", 
      "Incorrect item type on the stack trying to pop from %s",
      "Stack underflow", 
      "An item was going to be copied to itself from %s", 
      "Invalid symbol item passed as memvar %s",
   
      /* Texts */
   
      "YYYY.MM.DD",
      "I",
      "N"
   }
};

HB_LANG_ANNOUNCE( HU852 );

HB_CALL_ON_STARTUP_BEGIN( hb_lang_Init_HU852 )
   hb_langRegister( &s_lang );
HB_CALL_ON_STARTUP_END( hb_lang_Init_HU852 )
#if ! defined(__GNUC__) && ! defined(_MSC_VER)
   #pragma startup hb_lang_Init_HU852
#endif

